/*
 * Copyright LWJGL. All rights reserved.
 * License terms: https://www.lwjgl.org/license
 * MACHINE GENERATED FILE, DO NOT EDIT
 */
package org.lwjgl.util.hwloc;

import org.lwjgl.system.*;
import org.lwjgl.system.libffi.*;

import static org.lwjgl.system.APIUtil.*;
import static org.lwjgl.system.MemoryUtil.*;
import static org.lwjgl.system.libffi.LibFFI.*;

/**
 * Instances of this interface may be passed to the {@link HWLoc#hwloc_topology_set_userdata_import_callback topology_set_userdata_import_callback} method.
 * 
 * <h3>Type</h3>
 * 
 * <pre><code>
 * void (*{@link #invoke}) (
 *     hwloc_topology_t topology,
 *     hwloc_obj_t obj,
 *     char const *name,
 *     void const *buffer,
 *     size_t length
 * )</code></pre>
 */
@FunctionalInterface
@NativeType("void (*) (hwloc_topology_t, hwloc_obj_t, char const *, void const *, size_t)")
public interface topology_set_userdata_import_callbackI extends CallbackI {

    FFICIF CIF = apiCreateCIF(
        FFI_DEFAULT_ABI,
        ffi_type_void,
        ffi_type_pointer, ffi_type_pointer, ffi_type_pointer, ffi_type_pointer, ffi_type_pointer
    );

    @Override
    default FFICIF getCallInterface() { return CIF; }

    @Override
    default void callback(long ret, long args) {
        invoke(
            memGetAddress(memGetAddress(args)),
            memGetAddress(memGetAddress(args + POINTER_SIZE)),
            memGetAddress(memGetAddress(args + 2 * POINTER_SIZE)),
            memGetAddress(memGetAddress(args + 3 * POINTER_SIZE)),
            memGetAddress(memGetAddress(args + 4 * POINTER_SIZE))
        );
    }

    void invoke(@NativeType("hwloc_topology_t") long topology, @NativeType("hwloc_obj_t") long obj, @NativeType("char const *") long name, @NativeType("void const *") long buffer, @NativeType("size_t") long length);

}